'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _acorn = require('acorn');

var _astravel = require('astravel');

var _astring = require('astring');

var _astring2 = _interopRequireDefault(_astring);

require('./acorn_plugin');

var _astring_plugin = require('./astring_plugin');

var _astring_plugin2 = _interopRequireDefault(_astring_plugin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Should be replaced with our own version of acorn.
function convert(code, opts) {
  // Parse it into an AST and retrieve the list of comments
  var comments = [];
  var ast = (0, _acorn.parse)(code, Object.assign({
    ecmaVersion: 6,
    /* Should also have a halangVersion option in our acorn. */
    locations: true,
    onComment: comments,
    plugins: { halang: opts.ha }
  }, opts.acorn));
  // Attach comments to AST nodes
  (0, _astravel.attachComments)(ast, comments);
  // Format it into a code string
  var formattedCode = (0, _astring2.default)(ast, Object.assign({
    indent: '  ',
    lineEnd: '\n',
    comments: true,
    generator: _astring_plugin2.default
  }, opts.astring));
  return formattedCode;
}

exports.default = convert;
module.exports = exports['default'];